SystemOrganization addCategory: #DaliotsMappers!

!Rectangle methodsFor: '*DaliotsMappers' stamp: 'hjo 7/29/2008 16:39'!
interPointOfRatio: aPoint

	^self extent * aPoint + self origin

! !

!Rectangle methodsFor: '*DaliotsMappers' stamp: 'hjo 7/29/2008 16:39'!
interRatioOf: aPoint

	|extent displacement|
	extent := self extent.
	displacement := aPoint - origin.
	^(displacement x / extent x)@(displacement y / extent y)! !

Object subclass: #LinearMapper
	instanceVariableNames: 'domainFrom rangeFrom mapRatio unmapRatio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsMappers'!

!LinearMapper classSide methodsFor: 'as yet unclassified' stamp: 'hjo 6/10/2008 15:13'!
mapsDomainFrom: aSmallInteger to: aSmallInteger2 toRangeFrom: aSmallInteger3 to: aSmallInteger4 

	^self new
		domainFrom: aSmallInteger;
		rangeFrom: aSmallInteger3;
		mapRatio: (aSmallInteger4-aSmallInteger3) / (aSmallInteger2-aSmallInteger);
		setUnmapRatioFromMapRatio! !

!LinearMapper methodsFor: 'as yet unclassified' stamp: 'hjo 6/12/2008 09:08'!
domainFrom
	domainFrom! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/10/2008 15:14'!
domainFrom: aSmallInteger 
	
	domainFrom := aSmallInteger 
! !

!LinearMapper methodsFor: 'as yet unclassified' stamp: 'hjo 6/12/2008 09:08'!
map: aFloat 
	
	^(aFloat - self domainFrom) * self mapRatio + self rangeFrom! !

!LinearMapper methodsFor: 'as yet unclassified' stamp: 'hjo 6/30/2008 14:56'!
mapAll: anArray

	^anArray collect: [ : each | self map: each ]! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:06'!
mapRatio
	^mapRatio! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:05'!
mapRatio: aSmallInteger 

	mapRatio := aSmallInteger 
! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:08'!
rangeFrom

	^rangeFrom! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:05'!
rangeFrom: aSmallInteger 

	rangeFrom := aSmallInteger ! !

!LinearMapper methodsFor: 'as yet unclassified' stamp: 'hjo 6/12/2008 09:06'!
setUnmapRatioFromMapRatio

	self unmapRatio: self mapRatio reciprocal! !

!LinearMapper methodsFor: 'as yet unclassified' stamp: 'hjo 6/12/2008 09:11'!
unmap: aSmallInteger 

	^(aSmallInteger - self rangeFrom) * self unmapRatio + self domainFrom! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:11'!
unmapRatio

	^unmapRatio! !

!LinearMapper methodsFor: 'accessing' stamp: 'hjo 6/12/2008 09:07'!
unmapRatio: aFraction 

	unmapRatio := aFraction ! !

Object subclass: #MapperAbstract
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsMappers'!

MapperAbstract subclass: #IntervalMapper
	instanceVariableNames: 'foreRatio backRatio domainStart rangeStart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsMappers'!

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:33'!
backRatio

	^backRatio! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:33'!
backRatio: aNumber 

	backRatio := aNumber

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:33'!
domainStart

	^domainStart

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
domainStart: aNumber

	domainStart := aNumber

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
foreRatio

	^foreRatio

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
foreRatio: aNumber

	foreRatio := aNumber

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
from: domainInterval to: rangeInterval

	|rangeDiff domainDiff|
	rangeDiff := rangeInterval stop - rangeInterval start.
	domainDiff := domainInterval stop - domainInterval start.
	foreRatio := rangeDiff / domainDiff.
	backRatio := domainDiff / rangeDiff.

	rangeStart := rangeInterval start.
	domainStart := domainInterval start.

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
map: aNumber

	^(aNumber - domainStart) * foreRatio + rangeStart

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
mapSize: aNumber
	
	^aNumber * foreRatio

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:34'!
rangeStart

	^rangeStart

! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:35'!
rangeStart: aNumber

	rangeStart := aNumber
! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:35'!
reversed

	^self class new
		foreRatio: self backRatio;
		backRatio: self foreRatio;
		domainStart: self rangeStart;
		rangeStart: self domainStart! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:35'!
unmap: aNumber

	^(aNumber - rangeStart) * backRatio + domainStart! !

!IntervalMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:35'!
unmapSize: aNumber

	^aNumber * backRatio! !

!MapperAbstract classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:30'!
from: object1 to: object2

	^self new from: object1 to: object2

! !

!MapperAbstract classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:31'!
icon

	"This method is for Dolphin Smalltalk.
	^Icon fromFile: 'icon\mapper.ico'"! !

!MapperAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:29'!
from: domain to: range

	self subclassResponsibility

! !

!MapperAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:29'!
map: key

	self subclassResponsibility
! !

!MapperAbstract methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:30'!
unmap: value

	self subclassResponsibility
! !

MapperAbstract subclass: #QuadrangleMapper
	instanceVariableNames: 'domainQuadrangle rangeQuadrangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsMappers'!

!QuadrangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:31'!
from: quadrangle1 to: quadrangle2

	domainQuadrangle := quadrangle1.
	rangeQuadrangle := quadrangle2
! !

!QuadrangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:32'!
map: aPoint

	^rangeQuadrangle pointOfDivisionRatio: (domainQuadrangle divisionRatioOf: aPoint)

! !

!QuadrangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 16:32'!
unmap: aPoint

	^domainQuadrangle pointOfDivisionRatio: (rangeQuadrangle divisionRatioOf: aPoint)

! !

MapperAbstract subclass: #RectangleMapper
	instanceVariableNames: 'xMapper yMapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsMappers'!

!RectangleMapper classSide methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:50'!
new

	^super new initialize! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:48'!
foreRatio

	^self xMapper foreRatio @ self yMapper foreRatio! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
from: rect1 to: rect2

	xMapper from: (rect1 left to: rect1 right)  to: (rect2 left to: rect2 right).
	yMapper from: (rect1 top to: rect1 bottom) to: (rect2 top to: rect2 bottom)

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
initialize

	super initialize.
	xMapper := IntervalMapper new.
	yMapper := IntervalMapper new.

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
map: aPoint

	^(xMapper map: aPoint x)@(yMapper map: aPoint y)

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
mapRectangle: aRectangle

	^(self map: aRectangle origin) corner: (self map: aRectangle corner)

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
reversed

	^self class new 
		xMapper: self xMapper reversed;
		yMapper: self xMapper reversed

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
unmap: aPoint

	^(xMapper unmap: aPoint x)@(yMapper unmap: aPoint y)

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
unmapRectangle: aRectangle

	^(self unmap: aRectangle origin) corner: (self unmap: aRectangle corner)

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
xMapper

	^xMapper

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:49'!
xMapper: aIntervalMapper

	xMapper := aIntervalMapper

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:50'!
yMapper

	^yMapper

! !

!RectangleMapper methodsFor: 'as yet unclassified' stamp: 'hjo 7/29/2008 14:50'!
yMapper: aIntervalMapper

	yMapper := aIntervalMapper

! !

Object subclass: #RangeMapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DaliotsMappers'!

!Interval methodsFor: '*DaliotsMappers' stamp: 'hjo 7/29/2008 16:40'!
interPointOfRatio: aNumber

	^(self stop - self start) * aNumber + self start
! !

!Interval methodsFor: '*DaliotsMappers' stamp: 'hjo 7/29/2008 16:40'!
interRatioOf: aNumber

	^(aNumber - self start)/(self stop - self start)
! !
